\documentclass[a4paper]{article}
\usepackage[left=2.2cm,right=2.2cm,top=2.5cm,bottom=2.5cm]{geometry} % page settings
\usepackage{amsmath}
\usepackage{amssymb}
%\usepackage{amsthm}
%\usepackage{etoolbox}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
%\usepackage{framed}
\usepackage{fancyhdr}
%\usepackage{tikz}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\setlength{\parskip}{\medskipamount}
\setlength{\parindent}{0pt}

\pagestyle{fancy}
\lhead{
    \begin{tabular}{ll}
      Lab Course Deep Learning \\
      Winter term 2017/18
  \end{tabular}
}
\chead{}
\rhead{
  \begin{tabular}{ll}
    Fabian Glöckle \\
    05/11/2017
  \end{tabular}
}
\lfoot{}
\cfoot{}
\rfoot{} 


\begin{document}

\title{Deep Learning Lab Course Report 1}
\author{Fabian Glöckle}
\date{\today}
% \maketitle

\subsection*{Implementation of a simple multi-layer perceptron}

In this exercice, we implemented a simple multi-layer perceptron in python/numpy from scratch and applied it to the MNIST dataset. The code can be found on my github repo \footnote{\url{https://gitlab.com/fabian.g/deep-learning/tree/master}}.

\subsubsection*{Features}

\begin{itemize}
\item Forward propagation with linear, ReLU, tanh and sigmoid activation functions.
\item Linear (sum of squares loss) and softmax (negative log likelihood loss) output layers.
\item Backward propagation (analytical gradients).
\item Numeric gradient checking.
\item Training algorithms: gradient descent and minibatch stochastic gradient descent.
\end{itemize}

\subsubsection*{Optimising the architecture}

Playing around with the parameters, the following results on network architecture for MNIST were obtained:

\begin{itemize}
\item Minibatch-SGD performs significantly better than non-stochastic GD. Batch size did not seem to matter much, if the learning rate is adjusted accordingly.
\item High learning rates lead to instability, low ones to slow convergence.
\item ReLU and tanh work well as activation functions, sigmoid may have been badly initialized, or simply does not.
\item More hidden layers (3 instead of 1) and more units per layer (400 instead of 80) improve the output significantly, but require more careful setting of learning rate etc.
\item Variable $\frac{1}{n}$ learning rates decreased too fast, better results were obtained with constant learning rates.
\end{itemize}

\subsubsection*{Architecture for MNIST}

For recognizing handwritten digits from MNIST, the following architecture was used:

\begin{itemize}
  \item 2 ReLU-Layers with 400 units each
  \item Softmax output layer
  \item Minibatch-SGD as optimizer (batches of 64)
  \item constant learning rate of 0.4
  \item 40 epochs (of going through all the 50000 training samples)
\end{itemize}

\subsubsection*{Results}

The network achieved an accuracy on the \textit{validation} dataset of 1.98 percent. The runtime for the training was very high, more than 3 hours on my (rather old) machine. The training was running on the console instead of in Jupyter, so the weights weren't stored and I did not calculate the error of the network on the training set. The network parameters though were hardly tuned to fit the validation data well (that was the only larger architecture I tried), so test error might have been similar to validation error.

Figures 1 (a) and (b) show loss or classification error respectively, for both validation and training data.

\begin{figure}[h!] 
\begin{subfigure}{\textwidth}
\includegraphics[width=\textwidth]{loss.png} 
\caption{Loss by epoch. Red: validation data. Green: training data.}
\label{fig:subim1}
\end{subfigure}
\begin{subfigure}{\textwidth}
\includegraphics[width=\textwidth]{error.png}
\caption{Classification error by epoch. Orange: validation data. Blue: training data.}
\label{fig:subim2}
\end{subfigure}
 
\caption{Training curves}
\label{fig:image2}
\end{figure}

Interestingly, from epoch 10 on, the validation loss starts to increase again slightly. This is usually a sign of overfitting. Here however, even after epoch 10, the classification error continues to decrease for the validation data.

Our network does outperform simple networks with only one hidden layer. However even those very simple ones reach classification errors of 4 percent and less. To achieve results close to the expected 1.6 percent error, more fine-tuning, or even grid search, could be done to the hyperparameters (which was kept minimal here due to runtime constraints). Likewise, dropout could prove a good means against overfitting, which might even reduce the runtime.

\end{document}
